#!/bin/bash

if [ ! $# -eq 2 ]
then
    echo "Bad number of parameters"
	echo "Usage: ./convert.sh <source_dir> <target_dir>"
	echo ""
	echo "Example: ./convert.sh /opt/logserver/local /opt/logserver/remote"
    exit 1
fi

if [ -d $1 ]; then
	# Setting Aliases
	source_dir=$1
	target_dir=$2
	buffer_size=400
	CMD="./convertor"
	year_dir="$(ls ${source_dir})"

	# Year
	for year in ${year_dir}; do
		# Check if it's a "old" year.
		if [[ ${year} =~ "^[0-9]*$" ]]; then
			if [ -d "${source_dir}/${year}" ]; then
				echo "[DIRECTORY] ${source_dir}/${year}"

				# Month
				month_dir="$(ls ${source_dir}/${year})"
				for month in ${month_dir}; do
					if [ -d "${source_dir}/${year}/${month}" ]; then
						echo "    L[DIRECTORY] ${month}"
						
						# Day
						day_dir="$(ls ${source_dir}/${year}/${month})"
						for day in ${day_dir}; do
							if [ -d "${source_dir}/${year}/${month}/${day}" ]; then
								echo "        L[DIRECTORY] ${day}"
		
								# Load file
								file_dir="$(ls ${source_dir}/${year}/${month}/${day})"
								archive_dir="${target_dir}/${year}_${month}/${day}"

								if [ ! -d ${archive_dir} ]; then
									echo "            Missing target_dir, creating.."
									mkdir -p ${archive_dir}
								fi

								
								#for file in ${file_dir}; do
									echo "            bzcat ${source_dir}/${year}/${month}/${day}/* | ${CMD} ${archive_dir} $((${buffer_size}*1024*1024))"
									bzcat ${source_dir}/${year}/${month}/${day}/* | ${CMD} ${archive_dir} $((${buffer_size}*1024*1024))
								#done
	
								# Done converting files, bz2 the files
								echo "            bzip2 ${archive_dir}/*"
								bzip2 ${archive_dir}/*
							fi
						# End Day	
						done
					fi
				# End Month	
				done	
			fi
		fi
	# End Year
	done
fi

echo "Convert of all logs done."
